--    Program: 		CAPAREXT_SALESPERSON.sql
--    Description:  Extract AR Salesperson information 
--    Revision:     1st     
--    Parameter: 	1. set of books short name e.g. SOB_C999

set doc off;      
set verify off;
set serveroutput on size 1000000;
whenever sqlerror exit failure rollback;
alter session set nls_date_format='YYYYMMDD HH24:MI:SS';

declare   
   l_processed_count		number;
   l_rejected_count 		number;
   l_err_msg				varchar2(2000);
                    		
   l_utl_file       		utl_file.file_type;
   l_filename       		varchar2(255);
   l_pathname       		varchar2(100);
                    		
   l_ngo_sob				varchar2(20);
   
   l_set_of_books_id		number;
                    		  
   cursor cur_sales (p_set_of_books_id number) is
      select rs.* 
      from   ra_salesreps_all rs,
             hr_organization_information hoi
	  where  hoi.org_information_context = 'Operating Unit Information'
	  and    hoi.org_information3 = to_char(p_set_of_books_id)
	  and    hoi.organization_id = rs.org_id;

begin
   l_pathname := '/tmp';
   l_filename := 'CAPAR_SALESPERSON.dat';
   l_utl_file := utl_file.fopen(l_pathname, l_filename, 'w');
   
   l_processed_count := 0;
   l_rejected_count  := 0;
   
   l_ngo_sob := '&1';
   
   begin
     select set_of_books_id
     into   l_set_of_books_id
     from   gl_sets_of_books
     where  upper(short_name) = upper(l_ngo_sob);
   exception
     when others then
       dbms_output.put_line(l_ngo_sob||': set of books name not found');
       --raise;
   end;      

   for cur in cur_sales(l_set_of_books_id) loop   	
     
     -- output data 
     utl_file.put_line( l_utl_file, 
       cur.SALESREP_ID                   || chr(9) ||                                                                                                             
       cur.RESOURCE_ID                   || chr(9) ||                                                                                                             
       cur.LAST_UPDATE_DATE              || chr(9) ||                                                                                                             
       cur.LAST_UPDATED_BY               || chr(9) ||                                                                                                             
       cur.CREATION_DATE                 || chr(9) ||                                                                                                             
       cur.CREATED_BY                    || chr(9) ||                                                                                                             
       cur.LAST_UPDATE_LOGIN             || chr(9) ||                                                                                                             
       cur.SALES_CREDIT_TYPE_ID          || chr(9) ||                                                                                                             
       cur.NAME                          || chr(9) ||                                                                                                             
       cur.STATUS                        || chr(9) ||                                                                                                             
       cur.START_DATE_ACTIVE             || chr(9) ||                                                                                                             
       cur.END_DATE_ACTIVE               || chr(9) ||                                                                                                             
       cur.GL_ID_REV                     || chr(9) ||                                                                                                             
       cur.GL_ID_FREIGHT                 || chr(9) ||                                                                                                             
       cur.GL_ID_REC                     || chr(9) ||                                                                                                             
       cur.SET_OF_BOOKS_ID               || chr(9) ||                                                                                                             
       cur.SALESREP_NUMBER               || chr(9) ||                                                                                                             
       cur.ORG_ID                        || chr(9) ||
       cur.EMAIL_ADDRESS                 || chr(9) ||                                                                                                             
       cur.WH_UPDATE_DATE                || chr(9) ||                                                                                                             
       cur.PERSON_ID                     || chr(9) ||                                                                                                             
       cur.SALES_TAX_GEOCODE             || chr(9) ||                                                                                                             
       cur.SALES_TAX_INSIDE_CITY_LIMITS  || chr(9) ||                                                                                                             
       cur.OBJECT_VERSION_NUMBER         || chr(9) ||                                                                                                             
       cur.ATTRIBUTE_CATEGORY            || chr(9) ||                                                                                                             
       cur.ATTRIBUTE1                    || chr(9) ||                                                                                                             
       cur.ATTRIBUTE2                    || chr(9) ||                                                                                                             
       cur.ATTRIBUTE3                    || chr(9) ||                                                                                                             
       cur.ATTRIBUTE4                    || chr(9) ||                                                                                                             
       cur.ATTRIBUTE5                    || chr(9) ||                                                                                                             
       cur.ATTRIBUTE6                    || chr(9) ||                                                                                                             
       cur.ATTRIBUTE7                    || chr(9) ||                                                                                                             
       cur.ATTRIBUTE8                    || chr(9) ||                                                                                                             
       cur.ATTRIBUTE9                    || chr(9) ||                                                                                                             
       cur.ATTRIBUTE10                   || chr(9) ||                                                                                                             
       cur.ATTRIBUTE11                   || chr(9) ||                                                                                                             
       cur.ATTRIBUTE12                   || chr(9) ||                                                                                                             
       cur.ATTRIBUTE13                   || chr(9) ||                                                                                                             
       cur.ATTRIBUTE14                   || chr(9) ||                                                                                                             
       cur.ATTRIBUTE15                   || chr(9) ||                                                                                                             
       cur.SECURITY_GROUP_ID  
	 );                        
                               
	 l_processed_count := l_processed_count + 1;
   end loop;

   if l_processed_count = 0 then   
     l_rejected_count := l_rejected_count + 1;
     l_err_msg := l_ngo_sob || ': AR salesperson not found';
   end if;
   
   -- insert into log table
   insert into capcnv_log ( prog_id,process_date, record_processed,record_rejected,record_extracted,err_msg) 
    values ('CAPAREXT_SALESPERSON', sysdate, l_processed_count, l_rejected_count, l_processed_count-l_rejected_count, l_err_msg );
   
   commit;

   utl_file.fclose(l_utl_file);
exception 
  when others then
    dbms_output.put_line(sqlerrm);
    rollback;  
end;
/

--exit
